extends Control

enum StoryLine {
	TUT,
	KID,# = 5,
	FIRE,# = 1200,
	POLICE,# = 3600,
	CHOPPER,# = 7000,
	MILLITARY,# = 10000,
	ROCKETS,# = 120000,
	NASA,# = 140000,
	END# = 180000
}

var height = 5
var currentstory = 0
var goals = [5,900,1600,4000,7000,10000,13000,16000,20000]

## COMBAT
func add_spawner(what,fire_rate=3,firesound="res://assets/shoot.wav"):
	var n = AudioStreamPlayer.new()
	n.set_script(load("res://scripts/firesquad.gd"))
	n.projectile = what
	n.fire_rate = fire_rate
	n.stream = load(firesound)
	n.add_to_group("spawner")
	get_tree().root.add_child(n,true)

## GAMEOVER
func win():#When you win the game
	var end = load("res://GUI/end.tscn").instance()
	if(get_tree().root.has_node("MAINLEVEL")):
		end.get_node("TextureRect").modulate = get_tree().root.get_node("MAINLEVEL/Balloon").modulate
		get_tree().root.get_node("MAINLEVEL").queue_free()
	get_tree().root.add_child(end)
	reset()

func reset():
	get_tree().call_group("spawner","queue_free")
	currentstory=0
	height=5

## SOUND
func play_music(aud):#plays a different beat
	var mu = load(aud)
	$music.stream = mu
	$music.play()

func play_nar(aud):#Narration of what's going on
	var mu = load(aud)
	$narriation.stream = mu
	$narriation.play()

## LABELS
func update_height(val):#updates the height
	height += val
	$heights.text = "Height: " + str(height)
	if(height>goals[currentstory]):
		update_storyline()

func update_storyline():#Moves onto the next level
	currentstory+=1
	$level.text = StoryLine.keys()[currentstory]
	match(currentstory):
		StoryLine.KID:
			pass
		StoryLine.FIRE:
			$AnimationPlayer.play("caller")
			play_nar("res://assets/bringitdown.wav")
		StoryLine.POLICE:
			$AnimationPlayer.play("firemen")
			play_nar("res://assets/callthepolice.wav")
			add_spawner("res://object/bulletsm.tscn")
		StoryLine.CHOPPER:
			$AnimationPlayer.play("police")
			get_tree().call_group("ladder","queue_free")
			play_nar("res://assets/chopper.wav")
			add_spawner("res://object/bulletsm.tscn",1.1)
		StoryLine.MILLITARY:
			$AnimationPlayer.play("planecrash")
			play_nar("res://assets/crashlog.wav")
			get_tree().call_group("bg","set_modulate",Color.blueviolet)
			add_spawner("res://object/bulletlg.tscn",0.9,"res://assets/shoot2.wav")
		StoryLine.ROCKETS:
			$AnimationPlayer.play("rockets")
			play_nar("res://assets/graderockets.wav")
			add_spawner("res://object/rocket.tscn",2.9,"res://assets/shoot2.wav")
		StoryLine.NASA:
			$AnimationPlayer.play("nasa")
			var shuttle = load("res://object/shuttle.tscn").instance()
			get_tree().root.add_child(shuttle)
			play_nar("res://assets/NASA.wav")
			get_tree().call_group("bg","set_modulate",Color.indigo)
		StoryLine.END:
			$music.stop()
			win()